"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@collectable/core");
const internals_1 = require("../internals");
function normalizeIndex(index, size) {
    return index < 0 ? size + index < 0 ? -1 : size + index
        : index >= size ? -1 : index;
}
function at(index, tree) {
    return (index = normalizeIndex(index, tree._size)) === -1 ? void 0 : internals_1.findByIndex(index, tree);
}
exports.at = at;
function keyAt(index, tree) {
    const node = (index = normalizeIndex(index, tree._size)) === -1 ? void 0 : internals_1.findByIndex(index, tree);
    return core_1.isDefined(node) ? node.key : void 0;
}
exports.keyAt = keyAt;
function valueAt(index, tree) {
    const node = (index = normalizeIndex(index, tree._size)) === -1 ? void 0 : internals_1.findByIndex(index, tree);
    return core_1.isDefined(node) ? node.value : void 0;
}
exports.valueAt = valueAt;
function indexOf(key, tree) {
    return internals_1.findIndex(key, tree._root, tree._compare);
}
exports.indexOf = indexOf;
function iterateFromIndex(reverse, index, tree) {
    var path = (index = normalizeIndex(index, tree._size)) === -1 ? internals_1.PathNode.NONE : internals_1.findPathToIndex(index, tree._root);
    return new internals_1.RedBlackTreeIterator(path, reverse);
}
exports.iterateFromIndex = iterateFromIndex;

//# sourceMappingURL=at.js.map
