import { RedBlackTree } from '../internals';
/**
 * Removes the specified key from the tree. If the key was not in the tree, no changes are made, and the original tree
 * is returned.
 *
 * @export
 * @template K The type of keys in the tree
 * @template V The type of values in the tree
 * @param {K} key The key of the entry to be removed
 * @param {RedBlackTree<K, V>} tree The tree to be updated
 * @returns {RedBlackTree<K, V>} An updated copy of the tree, or the same tree if the input tree was already mutable
 */
export declare function remove<K, V>(key: K, tree: RedBlackTree<K, V>): RedBlackTree<K, V>;
